# ApacheCN 深度学习译文集

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)
> 
> 自豪地采用[谷歌翻译](https://translate.google.cn/)
> 
> 不要担心自己的形象，只关心如何实现目标。——《原则》，生活原则 2.3.c

* [在线阅读](https://dl.apachecn.org)
* [在线阅读（Gitee）](https://apachecn.gitee.io/apachecn-dl-zh/)
* [ApacheCN 面试求职交流群 724187166](https://jq.qq.com/?_wv=1027&k=54ujcL3)
* [ApacheCN 学习资源](http://www.apachecn.org/)

## 目录

+   [TensorFlow 1.x 深度学习秘籍](docs/tf-1x-dl-cookbook/README.md)
+   [使用 TensorFlow 构建机器学习项目中文版](docs/build-ml-proj-tf-zh/README.md)
+   [TensorFlow 深度学习中文第二版](docs/dl-tf-2e-zh/README.md)
+   [TensorFlow 深度学习实战指南中文版](docs/hands-on-dl-tf-zh/README.md)
+   [精通 TensorFlow 1.x](docs/mastering-tf-1x-zh/README.md)
+   [TensorFlow 机器学习秘籍中文第二版](docs/tf-ml-cookbook-2e-zh/README.md)
+   [与 TensorFlow 的初次接触](docs/first_contact_with_tensorFlow/README.md)
+   [TensorFlow 学习指南](docs/learning-tf-zh/README.md)
+   [TensorFlow Rager 教程](docs/tf-eager-tut/README.md)
+   [TensorFlow 高效编程](docs/effective-tf.md)
+   [图嵌入综述：问题，技术与应用](docs/ge-survey-arxiv-1709-07604-zh/README.md)
+   [基于深度学习的推荐系统：综述和新视角](docs/rs-survey-arxiv-1707-07435-zh/README.md)
+   [关于卷积神经网络我们理解了什么](docs/what-do-we-understand-about-convnet/README.md)
+   [机器学习超级复习笔记](docs/super-machine-learning-revision-notes/README.md)
+   [Python 迁移学习实用指南](docs/handson-tl-py/README.md)
+   [面向计算机视觉的深度学习](docs/dl-cv/README.md)
+   [深度学习快速参考](docs/dl-quick-ref/README.md)
+   [TensorFlow 2.0 快速入门指南](docs/tf-20-quick-start-guide/README.md)
+   [TensorFlow 入门](docs/get-start-tf/README.md)
+   [TensorFlow 卷积神经网络实用指南](docs/handson-cnn-tf/README.md)
+   [Python 人工智能中文版](docs/ai-py/README.md)
+   [Python 无监督学习实用指南](docs/handson-unsup-learn-py/README.md)
+   [生成对抗网络项目](docs/gan-proj/README.md)
+   [TensorFlow 智能移动项目](docs/intel-mobi-proj-tf/README.md)

## 下载

### Docker

```
docker pull apachecn0/apachecn-dl-zh
docker run -tid -p <port>:80 apachecn0/apachecn-dl-zh
# 访问 http://localhost:{port} 查看文档
```

### PYPI

```
pip install apachecn-dl-zh
apachecn-dl-zh <port>
# 访问 http://localhost:{port} 查看文档
```

### NPM

```
npm install -g apachecn-dl-zh
apachecn-dl-zh <port>
# 访问 http://localhost:{port} 查看文档
```

## 贡献指南

本项目需要校对，欢迎大家提交 Pull Request。

> 请您勇敢地去翻译和改进翻译。虽然我们追求卓越，但我们并不要求您做到十全十美，因此请不要担心因为翻译上犯错——在大部分情况下，我们的服务器已经记录所有的翻译，因此您不必担心会因为您的失误遭到无法挽回的破坏。（改编自维基百科）

## 联系方式

### 负责人

* [飞龙](https://github.com/wizardforcel): 562826179

### 其他

*   在我们的 [apachecn/apachecn-tf-zh](https://github.com/apachecn/apachecn-tf-zh) github 上提 issue.
*   发邮件到 Email: `apachecn@163.com`.
*   在我们的 [组织学习交流群](http://www.apachecn.org/organization/348.html) 中联系群主/管理员即可.

## 赞助我们

![](http://data.apachecn.org/img/about/donate.jpg)
