# 零、前言

《Python 元学习实用指南》解释了元学习的基础知识，并帮助您了解元学习的概念。 您将经历各种一次学习算法，例如连体，原型，关系和记忆增强网络，并在 TensorFlow 和 Keras 中实现它们。 您还将了解最新的元学习算法，例如与模型无关的元学习（MAML），Reptile 和通过元学习进行快速上下文适应（CAML）。 然后，您将探索如何使用元 SGD 快速学习，并发现如何使用元学习进行无监督学习。

# 这本书是给谁的

本书将帮助希望学习元学习作为训练机器学习模型的高级方法的机器学习爱好者，人工智能研究人员和数据科学家。 本书假定您具备有关机器学习概念的实用知识和对 Python 编程的全面了解。

# 充分利用这本书

本书需要以下软件：

*   Python
*   Anaconda
*   TensorFlow
*   Keras

# 下载示例代码文件

您可以从 [www.packt.com](http://www.packt.com) 的帐户中下载本书的示例代码文件。 如果您在其他地方购买了此书，则可以访问 [www.packt.com/support](http://www.packt.com/support) 并注册以将文件直接通过电子邮件发送给您。

您可以按照以下步骤下载代码文件：

1.  登录或注册 [www.packt.com](http://www.packt.com) 。
2.  选择支持选项卡。
3.  单击代码下载和勘误。
4.  在搜索框中输入书籍的名称，然后按照屏幕上的说明进行操作。

下载文件后，请确保使用以下最新版本解压缩或解压缩文件夹：

*   Windows 的 WinRAR/7-Zip
*   Mac 版 Zipeg/iZip/UnRarX
*   适用于 Linux 的 7-Zip/PeaZip

本书的代码包也[托管在 GitHub 上](https://github.com/PacktPublishing/Hands-On-Meta-Learning-with-Python)。 如果代码有更新，它将在现有的 GitHub 存储库中进行更新。

我们还有丰富的书籍和视频目录中的其他代码包，可通过[这里](https://github.com/PacktPublishing/)获得。 去看一下！

# 使用约定

本书中使用了许多文本约定。

`CodeInText`：指示文本，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，虚拟 URL，用户输入和 Twitter 句柄中的代码字。 这是一个示例：“`read_image`函数将图像作为输入并返回一个 NumPy 数组。”

代码块设置如下：

```py
import re
import numpy as np
from PIL import Image
```

**粗体**：表示新术语，重要单词或您在屏幕上看到的单词。

警告或重要提示如下所示。

提示和技巧如下所示。