# 零、前言

《Python 人工智能项目》将帮助您利用深度学习和强化学习构建基于人工智能的智能实用系统。 本书中介绍的项目涵盖了与医疗，电子商务，专家系统，监视时尚行业，基于移动的应用以及使用卷积神经网络，深度强化学习， 基于 LSTM 的 RNN，受限玻尔兹曼机，生成对抗网络，机器翻译和迁移学习。 本书中说明的构建智能应用的理论方面将使读者能够以有趣的方式扩展项目，并使其快速构建具有影响力的 AI 应用。 到本书结尾，您将足够熟练地构建自己的智能模型，以轻松解决任何类型的问题。

# 这本书是给谁的

本书适用于准备扩展其 AI 知识的数据科学家，机器学习专业人员和深度学习从业人员。 如果您想构建在每个复杂领域中都起着至关重要作用的现实生活中的智能系统，那么本书就是您所需要的。

# 本书涵盖的内容

第 1 章，“基于人工智能的系统”的基础知识，涵盖了如何使用机器学习，深度学习和强化学习来构建智能人工智能系统的基础知识。 我们将讨论各种人工神经网络，包括用于图像处理目的的 CNN 和用于自然语言处理目的的 RNN。

第 2 章，“迁移学习”涵盖了如何使用迁移学习来检测人眼中糖尿病性视网膜病变的情况以及确定视网膜病变的严重程度。 我们将探索 CNN，并学习如何使用能够在人眼眼底图像中检测出糖尿病性视网膜病变的 CNN 训练模型。

第 3 章，“神经机器翻译”涵盖了**循环神经网络**（**RNN**）架构的基础。 我们还将学习三种不同的机器翻译系统：基于规则的机器翻译，统计机器翻译和神经机器翻译。

第 4 章，“在 GAN 中使用 GAN” 进行时尚行业中的样式迁移，说明如何创建智能 AI 模型以生成具有与给定手袋相似样式的鞋子，反之亦然。 我们将使用原始 GAN 通过 GAN 的定制版本（例如 DiscoGAN 和 CycleGAN）来实现项目。

第 5 章，“视频字幕应用”讨论了 CNN 和 LSTM 在视频字幕中的作用，并说明了如何利用序列到视频（视频到文本）架构来构建视频字幕系统。

第 6 章，“智能推荐系统”讨论了推荐器系统，这些系统是处理数字数据过载问题的信息过滤系统，以便根据这些信息或信息提取信息。 我们将使用潜在分解进行协同过滤，并使用受限玻尔兹曼机来构建推荐系统。

第 7 章，“用于电影评论情感分析的移动应用”解释了如何使用机器学习即服务来使移动应用受益。 我们将使用 TensorFlow 创建一个 Android 移动应用，该应用将以电影评论作为输入并基于情感分析提供评分。

第 8 章，“用于客户服务的会话式 AI 聊天机器人”，介绍了聊天机器人在此期间的发展历程，并探讨了使用会话聊天机器人的好处。 我们还将研究如何创建聊天机器人以及什么是 LSTM 序列到序列模型。 我们还将为 Twitter 支持聊天机器人构建序列到序列模型。

第 9 章，“使用强化学习的自主式无人驾驶汽车”，介绍了强化学习和 Q 学习。 我们还将使用深度学习和强化学习来创建自动驾驶汽车。

第 10 章，“来自深度学习角度的验证码”，我们讨论了验证码是什么以及为什么需要验证码。 我们还将创建一个模型，以使用深度学习来打破验证码，然后如何使用对抗学习来生成它们。

# 充分利用这本书

读者应具有 Python 和人工智能的先验知识，才能完成本书中的项目。

# 下载示例代码文件

您可以从 [www.packt.com](http://www.packt.com) 的帐户中下载本书的示例代码文件。 如果您在其他地方购买了此书，则可以访问 [www.packt.com/support](http://www.packt.com/support) 并注册以将文件直接通过电子邮件发送给您。

您可以按照以下步骤下载代码文件：

1.  登录或注册 [www.packt.com](http://www.packt.com) 。
2.  选择支持选项卡。
3.  单击代码下载和勘误。
4.  在搜索框中输入书籍的名称，然后按照屏幕上的说明进行操作。

下载文件后，请确保使用以下最新版本解压缩或解压缩文件夹：

*   Windows 的 WinRAR/7-Zip
*   Mac 版 Zipeg/iZip/UnRarX
*   适用于 Linux 的 7-Zip/PeaZip

本书的代码包也托管在 [GitHub](https://github.com/PacktPublishing/Intelligent-Projects-using-Python) 上。 如果代码有更新，它将在现有的 GitHub 存储库中进行更新。

我们还有丰富的书籍和视频目录中的其他代码包，可通过[这里](https://github.com/PacktPublishing/)获得。 去看一下！

# 下载彩色图像

我们还提供了 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。 [您可以在此处下载](https://www.packtpub.com/sites/default/files/downloads/9781788996921_ColorImages.pdf)。

# 行动中的代码

[访问以下链接以查看正在运行的代码的视频](http://bit.ly/2Ru8rlU)。

# 使用约定

本书中使用了许多文本约定。

`CodeInText`：指示文本，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，虚拟 URL，用户输入和 Twitter 句柄中的代码字。 这是一个示例：“将下载的`WebStorm-10*.dmg`磁盘镜像文件安装为系统中的另一个磁盘。”

代码块设置如下：

```py
def get_im_cv2(path,dim=224):
     img = cv2.imread(path)
     resized = cv2.resize(img, (dim,dim), cv2.INTER_LINEAR)
     return resized
```

当我们希望引起您对代码块特定部分的注意时，相关的行或项目将以粗体显示：

```py
adam = optimizers.Adam(lr=0.00001, beta_1=0.9, beta_2=0.999, epsilon=1e-08, decay=0.0)
```

任何命令行输入或输出的编写方式如下：

```py
Cross Validation Accuracy: 0.6383708345200797
Validation Quadratic Kappa Score: 0.47422998110380984
```

**粗体**：表示新术语，重要单词或您在屏幕上看到的单词。 例如，菜单或对话框中的单词会出现在这样的文本中。 这是一个示例：“从管理面板中选择系统信息。”

警告或重要提示如下所示。

提示和技巧如下所示。