# 零、前言

TensorFlow 是最受欢迎的机器学习框架之一，其新版本 TensorFlow 2.0 改善了其简单性和易用性。 本书将帮助您了解和利用最新的 TensorFlow 功能。

《TensorFlow 2.0 的新增功能》首先关注高级概念，例如新的 TensorFlow Keras API，急切执行和高效的分发策略，这些策略可帮助您在多个 GPU 和 TPU 上运行机器学习模型。 本书随后将引导您完成构建数据摄取和训练管道的过程，并提供建议和最佳实践，以将数据提供给使用新`tf.keras` API 创建的模型。 您将探索使用 TensorFlow 服务和其他多平台部署构建推理管道的过程，然后再继续探索新发布的 AIY（本质上是自己动手的 AI）。 本书深入研究了核心 API，可帮助您构建统一的卷积层和循环层，并使用 TensorBoard 通过假设分析来可视化深度学习模型。

到这本书的结尾，您将了解 TensorFlow 2.0 和 TensorFlow 1.x 之间的兼容性，并将能够平稳地迁移到 TensorFlow 2.0。

# 这本书是给谁的

如果您是数据科学家，机器学习从业人员，深度学习研究人员或 AI 爱好者，希望将代码迁移到并探索 TensorFlow 2.0 的最新功能，则适合您。 要了解本书所涵盖的概念，必须具有 TensorFlow 和 Python 编程的经验。

# 充分利用这本书

读者需要具有 Python 和 TensorFlow 的基础知识。

# 下载示例代码文件

您可以从 [www.packt.com](http://www.packt.com) 的帐户中下载本书的示例代码文件。 如果您在其他地方购买了此书，则可以访问 [www.packt.com/support](http://www.packt.com/support) 并注册以将文件直接通过电子邮件发送给您。

您可以按照以下步骤下载代码文件：

1.  登录或注册 [www.packt.com](http://www.packt.com) 。
2.  选择支持选项卡。
3.  单击代码下载和勘误。
4.  在搜索框中输入书籍的名称，然后按照屏幕上的说明进行操作。

下载文件后，请确保使用以下最新版本解压缩或解压缩文件夹：

*   Windows 的 WinRAR/7-Zip
*   Mac 版 Zipeg/iZip/UnRarX
*   适用于 Linux 的 7-Zip/PeaZip

本书的代码包也托管在 [GitHub](https://github.com/PacktPublishing/What-s-New-in-TensorFlow-2.0) 上。

# 下载彩色图像

我们还提供了 PDF 文件，其中包含本书中使用的屏幕截图/图表的彩色图像。 [您可以在此处下载](_ColorImages.pdf)。

# 使用约定

本书中使用了许多文本约定。

`CodeInText`：指示文本，数据库表名称，文件夹名称，文件名，文件扩展名，路径名，虚拟 URL，用户输入和 Twitter 句柄中的代码字。 这是一个示例：“将下载的`WebStorm-10*.dmg`磁盘镜像文件安装为系统中的另一个磁盘。”

代码块设置如下：

```py
layer_name = tf.keras.Input(   shape=None,   batch_size=None,   name=None,   dtype=None,   sparse=False,   tensor=None,   **kwargs)
```

任何命令行输入或输出的编写方式如下：

```py
python3 -m pip --help
```

**粗体**：表示新术语，重要单词或您在屏幕上看到的单词。 例如，菜单或对话框中的单词会出现在这样的文本中。 这是一个...